---
layout: post
title: "Tor 0.2.1.8-alpha is now available"
permalink: tor-0.2.1.8-alpha-now-available
date: 2008-12-10
author: phobos
category: blog
tags: ["alpha release", "bugfixes"]
---

Tor 0.2.1.8-alpha fixes some crash bugs in earlier alpha releases,  
builds better on unusual platforms like Solaris and old OS X, and fixes  
a variety of other issues.

[https://www.torproject.org/download](https://www.torproject.org/download "https://www.torproject.org/download")

Changes in version 0.2.1.8-alpha - 2008-12-08  
**Major features:**

- New DirPortFrontPage option that takes an html file and publishes  
 it as "/" on the DirPort. Now relay operators can provide a  
 disclaimer without needing to set up a separate webserver. There's  
 a sample disclaimer in contrib/tor-exit-notice.html.

**Security fixes:**

- When the client is choosing entry guards, now it selects at most  
 one guard from a given relay family. Otherwise we could end up with  
 all of our entry points into the network run by the same operator.  
 Suggested by Camilo Viecco. Fix on 0.1.1.11-alpha.

**Major bugfixes:**

- Fix a DOS opportunity during the voting signature collection process  
 at directory authorities. Spotted by rovv. Bugfix on 0.2.0.x.
- Fix a possible segfault when establishing an exit connection. Bugfix  
 on 0.2.1.5-alpha.

**Minor bugfixes:**

- Get file locking working on win32. Bugfix on 0.2.1.6-alpha. Fixes  
 bug 859.
- Made Tor a little less aggressive about deleting expired  
 certificates. Partial fix for bug 854.
- Stop doing unaligned memory access that generated bus errors on  
 sparc64. Bugfix on 0.2.0.10-alpha. Fix for bug 862.
- Fix a crash bug when changing EntryNodes from the controller. Bugfix  
 on 0.2.1.6-alpha. Fix for bug 867. Patched by Sebastian.
- Make USR2 log-level switch take effect immediately. Bugfix on  
 0.1.2.8-beta.
- If one win32 nameserver fails to get added, continue adding the  
 rest, and don't automatically fail.
- Use fcntl() for locking when flock() is not available. Should fix  
 compilation on Solaris. Should fix Bug 873. Bugfix on 0.2.1.6-alpha.
- Do not mark smartlist\_bsearch\_idx() function as ATTR\_PURE. This bug  
 could make gcc generate non-functional binary search code. Bugfix  
 on 0.2.0.10-alpha.
- Build correctly on platforms without socklen\_t.
- Avoid potential crash on internal error during signature collection.  
 Fixes bug 864. Patch from rovv.
- Do not use C's stdio library for writing to log files. This will  
 improve logging performance by a minute amount, and will stop  
 leaking fds when our disk is full. Fixes bug 861.
- Stop erroneous use of O\_APPEND in cases where we did not in fact  
 want to re-seek to the end of a file before every last write().
- Correct handling of possible malformed authority signing key  
 certificates with internal signature types. Fixes bug 880. Bugfix  
 on 0.2.0.3-alpha.
- Fix a hard-to-trigger resource leak when logging credential status.  
 CID 349.

**Minor features:**

- Directory mirrors no longer fetch the v1 directory or  
 running-routers files. They are obsolete, and nobody asks for them  
 anymore. This is the first step to making v1 authorities obsolete.

**Minor features (controller):**

- Return circuit purposes in response to GETINFO circuit-status. Fixes  
 bug 858.

The original announcement can be found at [http://archives.seul.org/or/talk/Dec-2008/msg00129.html](http://archives.seul.org/or/talk/Dec-2008/msg00129.html "http://archives.seul.org/or/talk/Dec-2008/msg00129.html")

